︠b7cd1c60-68a5-492f-9b2e-b5b6f032cfe7i︠
%html
<p><span style="font-family: arial black,avant garde;"><span style="font-size: large;">Solids of Revolution</span></span></p>
<p>Scroll down the page until you see the "applet" field. Do not change the code in the cell immediately below.</p>
<p>Enter formulas for $f(x)$ and $g(x)$ and the limits $a$ and $b$ in the text fields. To redraw the solid, click Update. The solid can be rotated by dragging with the mouse.</p>
<p>The applet also optionally draws a "ring" used in the volume computation by the "method of rings". The "Coordinate" option gives the position of the ring. It must be chosen carefully to make sure the ring intercepts the surface.</p>
<p>Created by: L. Felipe Martins, <a href="mailto:l.martins@csuohio.edu">l.martins@csuohio.edu</a></p>

︡33001396-d904-4347-ad66-fecfbafb6942︡{"html": "<p><span style=\"font-family: arial black,avant garde;\"><span style=\"font-size: large;\">Solids of Revolution</span></span></p>\n<p>Scroll down the page until you see the \"applet\" field. Do not change the code in the cell immediately below.</p>\n<p>Enter formulas for $f(x)$ and $g(x)$ and the limits $a$ and $b$ in the text fields. To redraw the solid, click Update. The solid can be rotated by dragging with the mouse.</p>\n<p>The applet also optionally draws a \"ring\" used in the volume computation by the \"method of rings\". The \"Coordinate\" option gives the position of the ring. It must be chosen carefully to make sure the ring intercepts the surface.</p>\n<p>Created by: L. Felipe Martins, <a href=\"mailto:l.martins@csuohio.edu\">l.martins@csuohio.edu</a></p>"}︡
︠9b1cd7c3-6a84-4a85-b6c3-4ad87d4808dd︠
#auto
@interact
def _(func1=input_box('x^2',label='f(x)=',type=str),
      func2=input_box('x',label='g(x)=',type=str),a=0,b=1,
      axis=selector(['x','y'],label='Axis of rotation:',buttons=True),
      ring=checkbox(default=True,label='Draw ring'),
      coord=input_box(0.5,label='Ring coordinate:',type=float),auto_update=False):
    f = lambda x: sage_eval(func1,{'x':x})
    g = lambda x: sage_eval(func2,{'x':x})
    g2 = plot(f,a,b,color='orange')
    g2 += plot(g,a,b,color='green')
    g2 += line([[a,g(a)],[a,f(a)]],color='gray')
    g2 += line([[b,g(b)],[b,f(b)]],color='gray')
    show(g2,figsize=4)
    if axis=='x':
        f1 = lambda t,x: x
        f2 = lambda t,x: f(x)*cos(t)
        f3 = lambda t,x: f(x)*sin(t)
        g1 = lambda t,x: x
        g2 = lambda t,x: g(x)*cos(t)
        g3 = lambda t,x: g(x)*sin(t)
    else:
        f1 = lambda t,x: x*cos(t)
        f2 = lambda t,x: x*sin(t) 
        f3 = lambda t,x: f(x)
        g1 = lambda t,x: x*sin(t)
        g2 = lambda t,x: x*cos(t)
        g3 = lambda t,x: g(x)
    g3d = parametric_plot3d([f1,f2,f3],(0,2*pi),(a,b),color='orange',opacity=0.5)
    g3d += parametric_plot3d([g1,g2,g3],(0,2*pi),(a,b),color='green',opacity=0.5)
    if ring:
        r1 = lambda t,r: coord
        r2 = lambda t,r: r*cos(t)
        r3 = lambda t,r: r*sin(t)
        try:
            if axis=='x':
                lb = min(f(coord),g(coord))
                ub = max(f(coord),g(coord))
                g3d += parametric_plot3d([r1,r2,r3],(0,2*pi),(lb,ub),color='gray',opacity=1.0)
            else:
                x1 = find_root(lambda x:f(x)-coord,a,b)
                x2 = find_root(lambda x:g(x)-coord,a,b)
                lb = min(x1,x2)
                ub = max(x1,x2)
                g3d += parametric_plot3d([r2,r3,r1],(0,2*pi),(lb,ub),color='red',opacity=1.0)
        except ZeroDivisionError:
             print 'Unable to plot ring. Try changing coordinate.'
        print 'Ring:\nInner radius: %f\nOuter radius: %f' % (lb,ub)
    show(g3d)
︡cf4ec883-011c-4f74-9cb8-8bdc21987ca4︡{"html": "<!--notruncate--><div padding=6 id=\"div-interact-39\"> <table width=800px height=20px bgcolor=\"#c5c5c5\"\n                 cellpadding=15><tr><td bgcolor=\"#f9f9f9\" valign=top align=left><table><tr><td align=right><font color=\"black\">f(x)=&nbsp;</font></td><td><input type=\"text\" value=\"x^2\" size=80 onchange=\"interact(39, '_interact_.update(\\'39\\', \\'func1\\', 9, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals())')\"></input></td></tr>\n<tr><td align=right><font color=\"black\">g(x)=&nbsp;</font></td><td><input type=\"text\" value=\"x\" size=80 onchange=\"interact(39, '_interact_.update(\\'39\\', \\'func2\\', 10, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals())')\"></input></td></tr>\n<tr><td align=right><font color=\"black\">a&nbsp;</font></td><td><input type=\"text\" value=\"0\" size=80 onchange=\"interact(39, '_interact_.update(\\'39\\', \\'a\\', 11, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals())')\"></input></td></tr>\n<tr><td align=right><font color=\"black\">b&nbsp;</font></td><td><input type=\"text\" value=\"1\" size=80 onchange=\"interact(39, '_interact_.update(\\'39\\', \\'b\\', 12, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals())')\"></input></td></tr>\n<tr><td align=right><font color=\"black\">Axis of rotation:&nbsp;</font></td><td><table style=\"border:1px solid #dfdfdf; background-color:#efefef;\">\n<tr><td><button style=\"border-style:inset;\" value=\"0\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(39, '_interact_.update(\\'39\\', \\'axis\\', 13, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals())')\">x</button>\n<button style=\"border-style:outset;\" value=\"1\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(39, '_interact_.update(\\'39\\', \\'axis\\', 13, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals())')\">y</button>\n</td></tr></table></td></tr>\n<tr><td align=right><font color=\"black\">Draw ring&nbsp;</font></td><td><input type=\"checkbox\" checked width=200px onchange=\"interact(39, '_interact_.update(\\'39\\', \\'ring\\', 14, _interact_.standard_b64decode(\\''+encode64(this.checked)+'\\'), globals())')\"></input></td></tr>\n<tr><td align=right><font color=\"black\">Ring coordinate:&nbsp;</font></td><td><input type=\"text\" value=\"0.500000000000000\" size=80 onchange=\"interact(39, '_interact_.update(\\'39\\', \\'coord\\', 15, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals())')\"></input></td></tr>\n<tr><td colspan=2><input type=\"button\" value=\"Update\" onclick=\"interact(39, '_interact_.recompute(\\'39\\')')\">\n</td></tr>\n</table><div id=\"cell-interact-39\"><?__SAGE__START>\n        <table border=0 bgcolor=\"white\" width=100% height=100%>\n        <tr><td bgcolor=\"white\" align=left valign=top><pre><?__SAGE__TEXT></pre></td></tr>\n        <tr><td  align=left valign=top><?__SAGE__HTML></td></tr>\n        </table><?__SAGE__END></div></td>\n                 </tr></table></div>\n                 "}︡
︠b268ee6f-855d-4345-b415-6dbca1c476c0︠
interact?
︡d8503f2b-71b8-4832-8065-2e60ee326388︡︡
